#define WORKAROUND 0

struct Const
{
//	enum { CONST = N };
	static unsigned const CONST = 64;
};

/* Prevent compiler from using '15u' as a compile time constant.
 */
__constant__ unsigned a = 15u;

// Kernel
__global__ void test( uint2** inptr )
{
	uint2* ptr = *inptr;
	unsigned c = a;

#if !WORKAROUND
	ptr += Const::CONST - c;
#else
	unsigned wo = Const::CONST - c;
	ptr += wo;
#endif

	if( threadIdx.x == 0 )
		*inptr = ptr;
}

// Host stuff
#include <cstdio>
int main()
{
	// any pointer/value?
	uint2* dptr = 0;
	cudaMalloc( (void**)&dptr, sizeof(uint2)*1000 );

	uint2** pptr = 0;
	cudaMalloc( (void**)&pptr, sizeof(uint2*) );
	cudaMemcpy( pptr, &dptr, sizeof(uint2*), cudaMemcpyHostToDevice );

	test<<<1,32>>>( pptr );
	cudaThreadSynchronize();

	uint2* nptr = 0;
	cudaMemcpy( &nptr, pptr, sizeof(uint2*), cudaMemcpyDeviceToHost );

	uint2* expect = dptr + Const::CONST - 15u;
	printf( "%p vs %p [%p] : %s\n", expect, nptr, dptr, 
		(expect == nptr) ? "success" : "fail"
	);

	return 0;
}
